package com.example.demo;

import java.util.ArrayList;
import java.util.List;

//import org.slf4j.Logger;
//import org.slf4j.LoggerFactory;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import jakarta.validation.Valid;

@RestController
@RequestMapping("/message")
public class ApiController {
    // private final Logger log = LoggerFactory.getLogger(ApiController.class);

    public List<UserDto> dataList = new ArrayList<UserDto>();

    @PostMapping
    public UserDto create(@RequestBody @Valid UserDto testDto) {
        dataList.add(testDto);
        return testDto;
    }

    @GetMapping
    public List<UserDto> readAll() {
        return dataList;
    }

    @GetMapping("{id}")
    public UserDto read(@PathVariable(name = "id") int id) {
        return dataList.get(id);
    }

    @PutMapping("/{id}")
    public UserDto update(@PathVariable Integer id, @RequestBody UserDto testDto) {
        dataList.set(id, testDto);
        return testDto;
    }

    @DeleteMapping("/{id}")
    public UserDto delete(@PathVariable(name = "id") int id) {
        UserDto temp = dataList.remove(id);
        return temp;
    }

}
