package com.example.demo.comments.model;

import java.util.Date;
import java.util.Objects;

import com.example.demo.core.model.BaseEntity;
import com.example.demo.posts.model.PostEntity;
import com.example.demo.users.model.UserEntity;

public class CommentEntity extends BaseEntity {
    private UserEntity user;
    private PostEntity post;
    private Date time;
    private String text;

    public CommentEntity() {
        super();
    }

    public CommentEntity(Long id, UserEntity user, PostEntity post, Date time, String text) {
        super(id);
        this.user = user;
        this.post = post;
        this.time = time;
        this.text = text;
    }

    public UserEntity getUser() {
        return user;
    }

    public void setUser(UserEntity user) {
        this.user = user;
    }

    public PostEntity getPost() {
        return post;
    }

    public void setPost(PostEntity post) {
        this.post = post;
    }

    public Date getTime() {
        return time;
    }

    public void setTime(Date time) {
        this.time = time;
    }

    public String getText() {
        return text;
    }

    public void setText(String text) {
        this.text = text;
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, user, post, text, time);
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null || getClass() != obj.getClass())
            return false;
        final CommentEntity other = (CommentEntity) obj;
        return Objects.equals(other.getId(), id)
                && Objects.equals(other.getUser(), user)
                && Objects.equals(other.getPost(), post)
                && Objects.equals(other.getText(), text)
                && Objects.equals(other.getTime(), time);
    }
}
