package com.example.demo.users.api;

import java.util.ArrayList;

import com.fasterxml.jackson.annotation.JsonProperty;

import java.util.List;
import jakarta.validation.constraints.Min;
import jakarta.validation.constraints.NotBlank;
import jakarta.validation.constraints.NotNull;

public class UserDto {
    private Long id;
    @NotNull
    @Min(1)
    private String nickname;
    @NotBlank
    private String email;
    @NotBlank
    private String password;
    private List<Long> friendsId = new ArrayList<>();

    @JsonProperty(access = JsonProperty.Access.READ_ONLY)
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getNickname() {
        return nickname;
    }

    public void setNickname(String nickname) {
        this.nickname = nickname;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    @JsonProperty(access = JsonProperty.Access.READ_ONLY)
    public List<Long> getFriendsId() {
        return friendsId;
    }

    public void addFriendId(long Id) {
        friendsId.add(Id);
    }

}
