package com.example.demo.users.model;

import java.util.ArrayList;
import java.util.Objects;
import java.util.List;
import com.example.demo.core.model.BaseEntity;

public class UserEntity extends BaseEntity {
    private String nickname;
    private String email;
    private String password;
    private List<UserEntity> friends = new ArrayList<>();

    public UserEntity() {
        super();
    }

    public UserEntity(Long id, String nickname, String email, String password, List<UserEntity> friends) {
        super(id);
        this.nickname = nickname;
        this.email = email;
        this.password = password;
        this.friends = friends;
    }

    public String getNickname() {
        return nickname;
    }

    public void setNickname(String nickname) {
        this.nickname = nickname;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public List<UserEntity> getFriends() {
        return friends;
    }

    public void setFriends(List<UserEntity> friends) {
        this.friends = friends;
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, nickname, email, password, friends);
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null || getClass() != obj.getClass())
            return false;
        final UserEntity other = (UserEntity) obj;
        return Objects.equals(other.getId(), id)
                && Objects.equals(other.getFriends(), friends)
                && Objects.equals(other.getNickname(), nickname)
                && Objects.equals(other.getEmail(), email)
                && Objects.equals(other.getPassword(), password);
    }
}
