package com.example.demo.comments.model;

import java.util.Date;
import java.util.Objects;

import com.example.demo.core.model.BaseEntity;
import com.example.demo.posts.model.PostEntity;
import com.example.demo.users.model.UserEntity;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.JoinColumn;
import jakarta.persistence.ManyToOne;
import jakarta.persistence.Table;

@Entity
@Table(name = "comments")
public class CommentEntity extends BaseEntity {
    @ManyToOne
    @JoinColumn(name = "personEntity", nullable = false)
    private UserEntity person;
    @ManyToOne
    @JoinColumn(name = "postEntity", nullable = false)
    private PostEntity post;
    @Column(nullable = false)
    private Date time;
    @Column(length = 100)
    private String text;

    public CommentEntity() {
    }

    public CommentEntity(UserEntity person, PostEntity post, Date time, String text) {
        this.person = person;
        this.post = post;
        this.time = time;
        this.text = text;
    }

    public UserEntity getperson() {
        return person;
    }

    public void setperson(UserEntity person) {
        this.person = person;
    }

    public PostEntity getPost() {
        return post;
    }

    public void setPost(PostEntity post) {
        this.post = post;
    }

    public Date getTime() {
        return time;
    }

    public void setTime(Date time) {
        this.time = time;
    }

    public String getText() {
        return text;
    }

    public void setText(String text) {
        this.text = text;
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, person, post, text, time);
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null || getClass() != obj.getClass())
            return false;
        final CommentEntity other = (CommentEntity) obj;
        return Objects.equals(other.getId(), id)
                && Objects.equals(other.getperson(), person)
                && Objects.equals(other.getPost(), post)
                && Objects.equals(other.getText(), text)
                && Objects.equals(other.getTime(), time);
    }
}
