package com.example.demo.users.model;

import java.util.ArrayList;
import java.util.Objects;

import java.util.List;
import com.example.demo.core.model.BaseEntity;

import jakarta.persistence.CascadeType;
import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.FetchType;
import jakarta.persistence.JoinColumn;
import jakarta.persistence.JoinTable;
import jakarta.persistence.ManyToMany;
import jakarta.persistence.Table;

@Entity
@Table(name = "users")
public class UserEntity extends BaseEntity {
    @Column(nullable = false, length = 20)
    private String nickname;
    @Column(nullable = false, unique = true, length = 20)
    private String email;
    @Column(nullable = false, length = 20)
    private String password;
    @ManyToMany(fetch = FetchType.LAZY, cascade = CascadeType.REFRESH)
    @JoinTable(name = "user_friendship", joinColumns = @JoinColumn(name = "first_user_id", referencedColumnName = "Id", nullable = false), inverseJoinColumns = @JoinColumn(name = "second_user_id", referencedColumnName = "Id", nullable = false))
    private List<UserEntity> friends = new ArrayList<UserEntity>();

    public UserEntity() {
    }

    public UserEntity(String nickname, String email, String password, List<UserEntity> friends) {

        this.nickname = nickname;
        this.email = email;
        this.password = password;
        this.friends = friends;
    }

    public String getNickname() {
        return nickname;
    }

    public void setNickname(String nickname) {
        this.nickname = nickname;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public List<UserEntity> getFriends() {
        return friends;
    }

    public void setFriends(List<UserEntity> friends) {
        this.friends = friends;
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, nickname, email, password, friends);
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null || getClass() != obj.getClass())
            return false;
        final UserEntity other = (UserEntity) obj;
        return Objects.equals(other.getId(), id)
                && Objects.equals(other.getFriends(), friends)
                && Objects.equals(other.getNickname(), nickname)
                && Objects.equals(other.getEmail(), email)
                && Objects.equals(other.getPassword(), password);
    }
}