package com.example.demo.users.repository;

import java.util.Optional;
import java.util.List;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;

import com.example.demo.users.model.UserEntity;
import com.example.demo.users.model.UserTop;

public interface UserRepository extends CrudRepository<UserEntity, Long> {
    List<UserEntity> findByNickname(String nickname);

    Optional<UserEntity> findById(Long Id);

    Optional<UserEntity> findByEmailIgnoreCase(String email);

    @Query("select "
            + " u.nickname as user, coalesce(size(u.friends), 0) as count  "
            + "from UserEntity u "
            + "order by size(u.friends) desc")
    Page<UserTop> getFiveWithTopFriends(Pageable pageable);
}
