package com.example.demo.comments.repository;

import java.util.Optional;
import java.util.List;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.PagingAndSortingRepository;

import com.example.demo.comments.model.CommentEntity;

public interface CommentRepository
        extends CrudRepository<CommentEntity, Long>, PagingAndSortingRepository<CommentEntity, Long> {

    Optional<CommentEntity> findById(Long Id);

    List<CommentEntity> findByPostId(long postId);

    Page<CommentEntity> findAllByPostId(Long postId, Pageable pageable);

    @Query("SELECT p FROM PostEntity as p LEFT JOIN CommentEntity as c ON c.post.id=p.id GROUP BY p")
    Page<CommentEntity> findAllComments(Pageable pageable);
}