package com.example.demo.messages.model;

import java.util.Date;
import java.util.Objects;

import org.hibernate.annotations.OnDelete;
import org.hibernate.annotations.OnDeleteAction;

import com.example.demo.core.model.BaseEntity;
import com.example.demo.users.model.UserEntity;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.JoinColumn;
import jakarta.persistence.ManyToOne;
import jakarta.persistence.Table;

@Entity
@Table(name = "messages")
public class MessageEntity extends BaseEntity {

    @ManyToOne
    @OnDelete(action = OnDeleteAction.CASCADE)
    @JoinColumn(name = "userEntity", nullable = false)
    private UserEntity person;
    @ManyToOne
    @OnDelete(action = OnDeleteAction.CASCADE)
    @JoinColumn(name = "dialogFriend", nullable = false)
    private UserEntity friend;
    @Column(nullable = false)
    private Date time;
    @Column(length = 100)
    private String text;

    public MessageEntity() {
    }

    public MessageEntity(UserEntity person, UserEntity friend, Date time, String text) {
        this.person = person;
        this.friend = friend;
        this.text = text;
        this.time = time;
    }

    public UserEntity getFriend() {
        return friend;
    }

    public void setFriend(UserEntity friend) {
        this.friend = friend;
    }

    public UserEntity getPerson() {
        return person;
    }

    public void setPerson(UserEntity person) {
        this.person = person;
    }

    public Date getTime() {
        return time;
    }

    public void setTime(Date time) {
        this.time = time;
    }

    public String getText() {
        return text;
    }

    public void setText(String text) {
        this.text = text;
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, friend, person, time, text);
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null || getClass() != obj.getClass())
            return false;
        final MessageEntity other = (MessageEntity) obj;
        return Objects.equals(other.getId(), id)
                && Objects.equals(other.getPerson(), person)
                && Objects.equals(other.getFriend(), friend)
                && Objects.equals(other.getText(), text)
                && Objects.equals(other.getTime(), time);
    }

}
