package com.example.demo.messages.repository;

import java.util.List;
import java.util.Optional;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.PagingAndSortingRepository;
import org.springframework.data.repository.query.Param;

import com.example.demo.messages.model.MessageEntity;

public interface MessageRepository
        extends CrudRepository<MessageEntity, Long>, PagingAndSortingRepository<MessageEntity, Long> {
    Page<MessageEntity> findAll(Pageable pageable);

    List<MessageEntity> findByPersonId(Long personId);

    @Query("SELECT m FROM MessageEntity m  WHERE (m.person.id=:personId AND m.friend.id=:friendId) OR (m.friend.id=:personId AND m.person.id=:friendId)")
    Page<MessageEntity> findByPersonIdOrFriendId(@Param("personId") Long personId,
            @Param("friendId") Long friendId, Pageable pageable);

    Page<MessageEntity> findByPersonId(Long personId, Pageable pageable);

    Optional<MessageEntity> findById(Long Id);

}