package com.example.demo.posts.model;

import java.util.Date;
import java.util.Objects;

import org.hibernate.annotations.OnDelete;
import org.hibernate.annotations.OnDeleteAction;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.JoinColumn;
import jakarta.persistence.ManyToOne;
import jakarta.persistence.Table;

import com.example.demo.core.model.BaseEntity;
import com.example.demo.users.model.UserEntity;

@Entity
@Table(name = "posts")
public class PostEntity extends BaseEntity {
    @ManyToOne
    @OnDelete(action = OnDeleteAction.CASCADE)
    @JoinColumn(name = "user_Id", nullable = false)
    private UserEntity person;
    @Column(nullable = false)
    private Date time;
    @Column(length = 100)
    private String text;
    @Column
    private Long viewed;
    @Column
    private Long liked;

    public PostEntity() {
        super();
    }

    public PostEntity(UserEntity person, Date time, String text, Long viewed, Long liked) {
        this.person = person;
        this.text = text;
        this.time = time;
        this.viewed = viewed;
        this.liked = liked;
    }

    public UserEntity getPerson() {
        return person;
    }

    public void setPerson(UserEntity person) {
        this.person = person;
    }

    public Date getTime() {
        return time;
    }

    public void setTime(Date time) {
        this.time = time;
    }

    public String getText() {
        return text;
    }

    public void setText(String text) {
        this.text = text;
    }

    public Long getViewed() {
        return viewed;
    }

    public void setViewed(Long viewed) {
        this.viewed = viewed;
    }

    public Long getLiked() {
        return liked;
    }

    public void setLiked(Long liked) {
        this.liked = liked;
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, person, time, text, viewed, liked);
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null || getClass() != obj.getClass())
            return false;
        final PostEntity other = (PostEntity) obj;
        return Objects.equals(other.getId(), id)
                && Objects.equals(other.getPerson(), person)
                && Objects.equals(other.getText(), text)
                && Objects.equals(other.getTime(), time)
                && Objects.equals(other.getLiked(), liked)
                && Objects.equals(other.getViewed(), viewed);
    }

}
